<!-- <template>
  <div id="printContent" ref="imageWrapper">
    <h3>生产计划执行单</h3>

    <HJTABLE :SClist="pplan" :tableHeader="pplanHeader" :labelName="labelName.b1" :editable="editable"></HJTABLE>
    <HJTABLE :SClist="pplan" :tableHeader="pplanHeader2" :labelName="labelName.b1" :editable="editable"></HJTABLE>
    <HJTABLE :SClist="pplan" :tableHeader="pplanHeader3" :labelName="labelName.b1" :editable="editable"></HJTABLE>
    <HJTABLE :SClist="pplan" :tableHeader="pplanHeader4" :labelName="labelName.b1" :editable="editable"></HJTABLE>
    <HJTABLE :SClist="pplan2" :tableHeader="pplan2Header" :labelName="labelName.b1" :editable="editable"></HJTABLE>
  </div>
</template> -->
<template>
  <!-- <div class="header_nox">
    <el-button type="warning" circle @click="exportWord">下载</el-button>
    <el-button
      type="primary"
      circle
      v-show="!editable"
      @click="editable = !editable"
      >编辑</el-button
    >
    <el-button type="primary" v-show="editable" @click="saveData"
      >确定</el-button
    >
  </div> -->
  <div id="printContent" ref="imageWrapper">
    <h3>生产计划执行单</h3>
    <div class="title_form">
      <div class="title_form_input">
        <span>生产线：</span>
        <span>{{ headData.head.shengcx }}</span>
      </div>
      <div class="title_form_input">
        <span>产品：</span>
        <span>{{ headData.head.chanpin }}</span>
      </div>
      <div class="title_form_input">
        <span>日期：</span>
        <span>{{ headData.head.reportTime1 }}</span>
      </div>
      <div class="title_form_input">
        <span>班次：</span>
        <span>{{ headData.head.banci }}</span>
      </div>

      <!-- <div class="title_form_input">
                  <span>生产线：</span>
                  <span>四线</span>
                </div> -->
    </div>
    <el-divider />
    <HJTABLE :SClist="pplan" :tableHeader="pplanHeader"  :editable="editable"></HJTABLE>
    <HJTABLE :SClist="pplan" :tableHeader="pplanHeader2"  :editable="editable"></HJTABLE>
    <HJTABLE :SClist="pplan" :tableHeader="pplanHeader3"  :editable="editable"></HJTABLE>
    <HJTABLE :SClist="pplan" :tableHeader="pplanHeader4"  :editable="editable"></HJTABLE>
    <HJTABLE :SClist="pplan2" :tableHeader="pplan2Header"  :editable="editable"></HJTABLE>
  </div>
</template>
<script>
const item = {
  name: "",
  birth: "",
  province: "",
  city: "",
  address: "",
  phone: "",
};
const header = {
  prop: "key",
  label: "自定义",
  editable: "false",
  type: "input",
};
import { ref, reactive, onMounted } from "vue";
import { ElMessage } from "element-plus";
import { b3VoLast, b3save } from "@/api/b";
import html2canvas from "html2canvas";
import docxtemplater from "docxtemplater";
import PizZip from "pizzip";
import JSZipUtils from "jszip-utils";
import { saveAs } from "file-saver";
import HJTABLE from "@/components/arj/arj-table";
import { useRouter } from "vue-router";
import { headReport } from "@/api/head";
export default {
  name: "",
  components: { HJTABLE },
  props: {},

  setup(props) {
    const router = useRouter();
    const pplanHeader = reactive([{ prop: "shengcx", label: "线别", editable: "false", type: "text" }, { prop: "cpmc", label: "产品名称", editable: "false", type: "text" }, { prop: "cpmc_Model", label: "产品罐型", editable: "false", type: "text" }, { prop: "gsbh", label: "罐身版号", editable: "false", type: "text" }, { prop: "scddh", label: "生产订单", editable: "false", type: "text" }, { prop: "ddsl", label: "订单数量", editable: "false", type: "text" }, { prop: "bzfs", label: "包装方式", editable: "false", type: "text" }]);
    const pplanHeader2 = reactive([{ prop: "zfg", label: "自封盖", editable: "false", type: "text" }, { prop: "phg", label: "配货盖", editable: "false", type: "text" }, { prop: "bz", label: "备注", editable: "false", type: "text" }, { prop: "xsdd", label: "销售订单", editable: "false", type: "text" }, { prop: "kh", label: "客户", editable: "false", type: "text" }, { prop: "jhdd", label: "交货地点", editable: "false", type: "text" }]);
    const pplanHeader3 = reactive([{ prop: "clgg", label: "材料规格", editable: "false", type: "text" }, { prop: "kl", label: "开料", editable: "false", type: "text" }, { prop: "jypbh", label: "检验批编号", editable: "false", type: "text" }, { prop: "tzrq", label: "通知日期", editable: "false", type: "text" }, { prop: "scrq", label: "生产日期", editable: "false", type: "text" }, { prop: "wcrq", label: "完成日期", editable: "false", type: "text" }, { prop: "zzgy", label: "制造工艺", editable: "false", type: "text" }, { prop: "gydh", label: "工艺单号", editable: "false", type: "text" }, { prop: "slkz", label: "数量控制", editable: "false", type: "text" }, { prop: "mbrcl", label: "目标日产量", editable: "false", type: "text" }, { prop: "bh", label: "版号", editable: "false", type: "text" }]);
    const pplanHeader4 = reactive([{ prop: "wlms", label: "物料描述", editable: "false", type: "text" }, { prop: "cpgg", label: "产品规格", editable: "false", type: "text" }, { prop: "gjnj", label: "钢卷内径", editable: "false", type: "text" }, { prop: "bmtl", label: "表面涂料", editable: "false", type: "text" }, { prop: "kjfs", label: "开卷方式", editable: "false", type: "text" }, { prop: "dbzs", label: "单包张数", editable: "false", type: "text" }, { prop: "pcgg", label: "片材规格", editable: "false", type: "text" }, { prop: "bsxs", label: "标示形式", editable: "false", type: "text" }, { prop: "sfys", label: "是否印刷", editable: "false", type: "text" }, { prop: "yt", label: "用途", editable: "false", type: "text" }, { prop: "bianzhi", label: "编制", editable: "false", type: "text" }]);

    const pplan2Header = reactive([{ prop: "xh", label: "序号", editable: "false", type: "text" }, { prop: "zjwlbh", label: "组件物料编码", editable: "false", type: "text" }, { prop: "zjwlms", label: "组件物料描述", editable: "false", type: "text" }, { prop: "xqsl", label: "需求数量", editable: "false", type: "text" }, { prop: "dw", label: "单位", editable: "false", type: "text" }, { prop: "gys", label: "供应商", editable: "false", type: "text" }]);

    let labelName = {
      b1: "生产记录",
      b2: "废品统计",
      b3: "生产废品",
      b4: "质量记录",
    };
    let tableData = reactive([]);

    const formInline = reactive({
      user: "",
      region: "",
    });
    const imageWrapper = ref(null);

    let headData = reactive({
      head: {},
    });
    let hanjiRdData = reactive({
      scjhList: {},
    });
    let SClist = ref([]);
    let hjData = ref({});
    let ssList = ref([]);
    let pplan = ref([]);
    let pplan2 = ref([]);
    const submitForm = () => { };

    const handleEdit = (row) => {
      row.editable = true;
    };
    const handleDelete = (index) => {
      this.tableData.splice(index, 1);
    };
    const prepend = (index) => {
      item.editable = true;
      this.tableData.splice(index, 0, item);
    };
    const append = (index) => {
      item.editable = true;
      this.tableData.splice(index + 1, 0, item);
    };
    const deleteCurrentColumn = (index) => {
      this.tableHeader.splice(index, 1);
    };
    const insertBefore = (index) => {
      header.editable = true;
      this.tableHeader.splice(index, 0, header);
    };
    const getListData = async () => {
      const data = await b3VoLast();
      console.log("生产计划。。。", data.data);
     
        headData.head = data.data.head;
        pplan.value = [data.data.pplan];
        pplan2.value = data.data.pplan2List
        console.log('...pplan',pplan)
        // hjData.value = {
        //   ...headData.head,
        //   ...hanjiRdData.scjhList,
        // };

        SClist.value = data.data.pplan2List;

    };

    const saveData = async () => {
      editable = false;

      let data = {
        scjhList: SClist.value,
        head: headData.head,
      };
      // console.log("save data...", data);
      const dt = await save(data);
      if (dt.code == 0) {
        ElMessage({
          message: "修改成功",
          type: "success",
        });
      }
      // console.log(dt);
    };
    //截图
    const toImage = () => {
      html2canvas(imageWrapper.value, {
        logging: "false",
        allowTaint: true,
        scale: window.devicePixelRatio,
        // width: shareContent.clientWidth, //dom 原始宽度
        // height: shareContent.clientHeight,
        scrollY: 0,
        scrollX: 0,
        useCORS: true,
        backgroundColor: "#ffffff",
      }).then(function (canvas) {
        // console.log(canvas);
        let imgUrl = canvas.toDataURL("image/png");
        var tempLink = document.createElement("a"); // 创建一个a标签
        tempLink.style.display = "none";
        tempLink.href = imgUrl;
        tempLink.setAttribute("download", "焊机/后道工序生产质量记录"); // 给a标签添加下载属性
        if (typeof tempLink.download === "undefined") {
          tempLink.setAttribute("target", "_blank");
        }
        document.body.appendChild(tempLink); // 将a标签添加到body当中
        tempLink.click(); // 启动下载
        document.body.removeChild(tempLink); // 下载完毕删除a标签
        window.URL.revokeObjectURL(imgUrl);
      });
    };
    // 点击导出word
    function exportWord() {
      // 读取并获得模板文件的二进制内容
      JSZipUtils.getBinaryContent("hj.docx", function (error, content) {
        // input.docx是模板。我们在导出的时候，会根据此模板来导出对应的数据
        // 抛出异常
        if (error) {
          throw error;
        }

        // 创建一个JSZip实例，内容为模板的内容
        let zip = new PizZip(content);
        // 创建并加载docxtemplater实例对象
        let doc = new docxtemplater().loadZip(zip);
        // 设置模板变量的值
        doc.setData({
          ...hjData.value,

          // table: hanjiRdData.hanjiRd,
        });

        try {
          // 用模板变量的值替换所有模板变量
          doc.render();
        } catch (error) {
          // 抛出异常
          let e = {
            message: error.message,
            name: error.name,
            stack: error.stack,
            properties: error.properties,
          };
          // console.log(JSON.stringify({ error: e }));
          throw error;
        }

        // 生成一个代表docxtemplater对象的zip文件（不是一个真实的文件，而是在内存中的表示）
        let out = doc.getZip().generate({
          type: "blob",
          mimeType:
            "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
        });
        // 将目标文件对象保存为目标类型的文件，并命名
        saveAs(out, "焊机/后道工序生产质量记录.docx");
      });
    }
    getListData();
    onMounted(() => { });
    return {
      pplan,
      pplan2,
      labelName,
      b3VoLast,
      saveData,
      submitForm,
      formInline,
      tableData,
      insertBefore,
      deleteCurrentColumn,
      append,
      prepend,
      handleDelete,
      handleEdit,
      pplanHeader,
      pplanHeader2,
      pplanHeader3,
      pplanHeader4,
      pplan2Header,
      getListData,
      headData,
      toImage,
      imageWrapper,
      SClist,
      ssList,
      exportWord,
    };
  },
};
</script>
<style lang="scss" scoped>
.header_nox {
  text-align: right;
}

#printContent h3 {
  text-align: center;
  margin-bottom: 40px;
  font-size: 26px;
  font-weight: bold;
}

.title_form {
  display: flex;
  justify-content: space-around;
  align-items: center;
  // margin-bottom: 20px;
}

.title_form_input {
  font-size: 16px;
}
</style>
